-- Часть 1.


-- *** *** *** *** *** --
--      Остальное      --
-- *** *** *** *** *** --

function getNextValue(v, n)
	if v == '+' and n == 1 then
		return '-';
	elseif v == '+' and n == 2 then
		return 'V';
	elseif v == '+' and n == 3 then
		return 'I';
	
	elseif v == '-' and n == 1 then
		return 'V';
	elseif v == '-' and n == 2 then
		return 'I';
	elseif v == '-' and n == 3 then
		return '+';
	
	elseif v == 'V' and n == 1 then
		return 'I';
	elseif v == 'V' and n == 2 then
		return '+';
	elseif v == 'V' and n == 3 then
		return '-';
	
	elseif v == 'I' and n == 1 then
		return '+';
	elseif v == 'I' and n == 2 then
		return '-';
	elseif v == 'I' and n == 3 then
		return 'V';
	end;
end;

playGameDlg = room {
	nam = 'Игровая доска';
	hideinv = true;
	way = {'lab'};
	exit = 'Странная игра...';
	entered = function(s)
		p 'Я сел играть. На доске 4 клетки. В каждую помещается одна фишка.';
		s.num = 0;
		s.g[1] = '?';
		s.g[2] = '?';
		s.g[3] = '?';
		s.g[4] = '?';
	end;
	var {
		num = 0;
		g = {
			[1] = '?';
			[2] = '?';
			[3] = '?';
			[4] = '?';
		};
		newG = {
			[1] = '';
			[2] = '';
			[3] = '';
			[4] = '';
		};
	};

	act = function(s, w)
		s.num = s.num + 1;
		s.g[s.num] = w;
		p( 'Фишки на доске: ^^' .. s.g[1] .. ' .. ' .. s.g[2] .. ' .. ' .. s.g[3] .. ' .. ' .. s.g[4] .. '^^' );
		if s.num == 4 then
			s.newG[1] = s.g[1];
			s.newG[2] = getNextValue(s.g[2], 2);
			s.newG[3] = getNextValue(s.g[3], 1);
			s.newG[4] = getNextValue(s.g[4], 3);
			p( 'Человек в белом халате провёл рукой над доской и символы на фишках поменялись на: ^^' .. s.newG[1] .. ' .. ' .. s.newG[2] .. ' .. ' .. s.newG[3] .. ' .. ' .. s.newG[4] .. '^^' );
			if s.newG[1] == '+' and
				s.newG[2] == '+' and
				s.newG[3] == '+' and
				s.newG[4] == '+' then
				walk('showVision4');
			else
				walk('lab');
			end;
		end;
	end;
	obj = { vobj('+', '{+} .. '),
			vobj('I', '{I} .. '),
			vobj('V', '{V} .. '),
			vobj('-', '{-}'),
	};
};

openingLockDlg = room {
	nam = 'Взлом замка';
	var {
		num = {
			[1] = '';
			[2] = '';
			[3] = '';
			[4] = '';
			};
		numCount = 0;
	};
	hideinv = true;
	way = {'townLamp'};
	exit = function()
		if not have(keyOnCircuit) then
			p 'Попробую открыть позже.';
		end;
	end;
	entered = function(s)
		p 'На чемодане установлен кодовый замок. Попробую подобрать код...';
		s.numCount = 0;
	end;
	act = function(s, w)
		s.numCount = s.numCount + 1;
		if s.numCount > 4 then
			p 'О! Баг выскочил!';
		else
			if s.numCount == 1 then
				p ('Первая цифра -- ' .. '"' .. w .. '".');
			elseif s.numCount == 2 then
				p ('Вторая цифра -- ' .. '"' .. w .. '".');
			elseif s.numCount == 3 then
				p ('Третья цифра -- ' .. '"' .. w .. '".');
			end;
			s.num[s.numCount] = w;
		end
		if s.numCount < 4 then
			p ('Теперь цифра ' .. ( s.numCount + 1 ) .. '...');
		end;
		if s.numCount == 4 then
			p ('Последняя цифра -- ' .. w .. '. Проверим.');
			if s.num[1] == '3' and
				s.num[2] == '5' and
				s.num[3] == '4' and
				s.num[4] == '3' then
				p 'Замок открылся.';
				if not have(keyOnCircuit) then
					p 'Внутри чемодана, среди кучи разных бумаг, я нашёл маленький ключ на цепочке.';
					if have( paperText ) then
						p 'Я посмотрел на клочок бумаги -- цифры на нём исчезли! Теперь это обычный чистый лист.';
					end;
					take(keyOnCircuit);
				else
					p 'Внутри чемодана я нашёл только кучу разных бумаг.';
				end;
			else
				p 'Нет. Замок не открылся. Наверное, я что-то делаю не так.';
			end;
			walk('townLamp');
		end;
	end;
	obj = { vobj('1', '{1}...'),
			vobj('2', '{2}...'),
			vobj('3', '{3}...'),
			vobj('4', '{4}...'),
			vobj('5', '{5}...'),
			vobj('6', '{6}...'),
			vobj('7', '{7}...'),
			vobj('8', '{8}...'),
			vobj('9', '{9}...'),
			vobj('0', '{0}...'),
	};
};